import time
from flask import Blueprint, request, jsonify, session
from model.Model import Organization,Role,Menu,Element,Permissions,User
from manager.serverCenter import server
from manager.tools import sqlOrmToJson
db=server.db


identity = Blueprint("identity",__name__,url_prefix='/identity')


@identity.route("/add_organization",methods=["POST"])
def add_Organization():
    data=request.json
   
    if db.session.query(Organization).filter(Organization.name==data.get("name"),Organization.parent_id==(data.get("parent_id") or 0)).all():
        db.session.close()
        return jsonify({"code": 402, "message": "部门名重复"}),402
    else:
        org=Organization(name=data.get("name"),parent_id=(data.get("parent_id") or 0),find_path='',path='')
        db.session.add(org)
        db.session.flush()
        thispath=db.session.query(Organization).filter_by(id=data.get("parent_id")).first()
        if not thispath:
            find_path,path=f"-{org.id}-",org.name
        else:
            find_path,path=thispath.find_path+str(org.id)+"-",thispath.path+"/"+org.name
        org.path,org.find_path=path,find_path
        db.session.commit()
        db.session.close()
        return jsonify({"code": 200, "message": "新增成功"}),200
    


@identity.route("/delete_organization/<id_>",methods=["DELETE"])
def delete_Organization(id_):
    res=db.session.query(Organization).filter(Organization.find_path.like(f"%-{id_}-%")).all()
    for each in res:
        if db.session.query(User).filter_by(organization_id=each.id).count()>0:
            name=each.name
            db.session.rollback()
            db.session.close()
            return jsonify({"code": 503, "message": f"\'{name}\'下已绑定用户,请先删除用户"}),503
        db.session.delete(each)
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": f"删除成功"}),200
    

@identity.route("/organization",methods=["GET"])
def organization():
    orgall=db.session.query(Organization.id,Organization.name,Organization.find_path).all()
    orgall=sorted(orgall,key=lambda x:len(list(filter(None,x.find_path.split("-")))),reverse=False)
    result=[]
    for each in orgall:
        target=result
        info=list(filter(None,each.find_path.split("-")))
        for path in info:
            breakinfo=False
            for index in range(len(target)):
                if target[index]["id"]==int(path):
                    target[index]["_showChildren"]=True
                    target=target[index]["children"]
                    breakinfo=True
                    break
            if not breakinfo:
                target.append({"name":each.name,"id":each.id,"children":[]})
        target=result
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功", "data": result}),200

@identity.route("/organization_list",methods=["GET"])
def organization_list():
    a=db.session.query(Organization.id,Organization.path).all()
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功", "data": sqlOrmToJson(a)}),200
    


@identity.route("/add_role",methods=["POST"])
def add_role():
    data=request.json
    time_ = time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(time.time()))
    if db.session.query(Role).filter_by(name=data.get("name")).first():
        db.session.close()
        return jsonify({"code": 402, "message": "已有该角色"}),402
    org=Role(name=data.get("name"))
    db.session.add(org)
    db.session.flush
    defaut_nemu_show=db.session.query(Menu.id).filter_by(default_show=1).all()
    for each in defaut_nemu_show:
        per=Permissions(type=0,p_id=each.id,role_id=org.id,update_date=time_,update_user=session.get("id") or 0)
        db.session.add(per)
    defaut_element_show=db.session.query(Element.id).filter_by(default_show=1).all()
    for each in defaut_element_show:
        per=Permissions(type=1,p_id=each.id,role_id=org.id,update_date=time_,update_user=session.get("id") or 0)
        db.session.add(per)
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "新增成功"}),200
    
@identity.route("/update_role/<id_>",methods=["POST"])
def update_role(id_):
    data=request.json
    db.session.query(Role).filter_by(id=int(id_)).update(data)
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "更新成功"}),200

@identity.route("/role_list",methods=["GET"])
def role_list():
    a=sqlOrmToJson(db.session.query(Role.name,Role.id).all())
    # for i in range(len(a)):
    #     all_menu=db.session.query(Menu.id,Menu.name,Permissions.status).join(Permissions,Permissions.p_id==Menu.id).filter(Permissions.type==0,Permissions.role_id==a[i]["id"]).all()
    #     a[i]["menu"]=sqlOrmToJson(all_menu)
    #     for j in range(len(a[i]["menu"])):
    #         all_element=db.session.query(Element.id,Element.name,Permissions.status).filter(Permissions.p_id==Element.id,Permissions.type==1,Permissions.role_id==a[i]["id"],Element.menu_id==a[i]["menu"]["id"]).all()
    #         a[i]["menu"][j]["element"]=sqlOrmToJson(all_element)
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功","data":sqlOrmToJson(a)}),200

@identity.route("/delete_role/<id_>",methods=["DELETE"])
def delete_role(id_):
    if db.session.query(User).filter_by(role_id=int(id_)).count()>0:
        db.session.close()
        return jsonify({"code": 503, "message": "该角色下绑定了成员，请移除后再删除"}),503
    db.session.query(Permissions).filter_by(role_id=int(id_)).delete()
    db.session.query(Role).filter_by(id=int(id_)).delete()
    db.session.commit()    
    db.session.close()
    return jsonify({"code": 200, "message": "删除成功"}),200

@identity.route("/get_permissions/<id_>",methods=["GET"])
def get_permissions(id_):
    a=db.session.query(Permissions.id,Permissions.type,Permissions.p_id).filter_by(role_id=int(id_)).all()
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功","data":sqlOrmToJson(a)}),200

@identity.route("/update_permissions/<id_>",methods=["POST"])
def update_permissions(id_):
    id_=int(id_)
    time_ = time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(time.time()))
    data=request.json
    new_menu_ids=[i for i in data if i.get("type")==0]
    new_ele_ids=[i for i in data if i.get("type")==1]
    a=db.session.query(Permissions).filter_by(role_id=id_).all()
    old_menu_ids=[i.id for i in a if i.type==0]
    old_ele_ids=[i.id for i in a if i.type==1]
    for i in filter(lambda x:x not in old_ele_ids,new_ele_ids):
        a=Permissions(role_id=id_,type=1,p_id=i.get("id"),update_date=time_,update_user=session.get("id") or 0)
        db.session.add(a)
    for i in filter(lambda x:x not in old_menu_ids,new_menu_ids):
        a=Permissions(role_id=id_,type=0,p_id=i.get("id"),update_date=time_,update_user=session.get("id") or 0)
        db.session.add(a)
    db.session.query(Permissions).filter(Permissions.id.in_(filter(lambda x:x not in new_ele_ids,old_ele_ids))).delete()
    db.session.query(Permissions).filter(Permissions.id.in_(filter(lambda x:x not in new_menu_ids,old_menu_ids))).delete()
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "修改成功"}),200
        
@identity.route("/add_menu",methods=["POST"])
def add_meun():
    data=request.json
    time_ = time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(time.time()))
    menu=Menu(name=data.get("name"),router=data.get("router"),icon=data.get("Icon"),parent_id=data.get("parent_id") or 0,default_show=data.get("default_show") or 0)
    db.session.add(menu)
    db.session.flush()
    ppath='/'
    if data.get("parent_id"):
        pmeun=db.session.query(Menu).filter_by(id=data.get("parent_id")).first()
        ppath=pmeun.path
    menu.path=ppath+str(menu.id)+"/"
    if menu.default_show:
        allRole=db.session.query(Role.id).all()
        for each in allRole:
            per=Permissions(role_id=each.id,type=0,p_id=menu.id,update_date=time_,update_user=session.get("id") or 0)
            db.session.add(per)
    
    for each in data.get("elements"):
        add_ele(each,menu.id,time_)
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "添加成功"}),200

@identity.route("/delete_meun/<id_>",methods=["DELETE"])
def delete_meun(id_):
    try:     
        db.session.query(Permissions).filter(Permissions.type==1,Permissions.p_id==Element.id,Element.menu_id==Menu.id,Menu.path.like(f"%{str(id_)}%")).delete()
        db.session.query(Permissions).filter(Permissions.type==0,Permissions.p_id==Menu.id,Menu.path.like(f"%{str(id_)}%")).delete()
        db.session.query(Element).filter(Element.menu_id==Menu.id,Menu.path.like(f"%/{str(id_)}/%")).delete()
        db.session.query(Menu).filter(Menu.path.like(f"/%{str(id_)}/%")).delete()
        db.session.commit()
        db.session.close()
        return jsonify({"code": 200, "message": "删除成功"}),200
    except:
        db.session.rollback()
        db.session.close()
        return jsonify({"code": 503, "message": "删除失败"}),503
    
def add_ele(each,menu_id,time_):
    element=Element(menu_id=menu_id,u_id=each.get("u_id"),name=each.get("name"),default_show=each.get("default_show") or 0)
    db.session.add(element)
    db.session.flush()
    if element.default_show:
        allRole=db.session.query(Role.id).all()
        for each in allRole:
            pre=Permissions(role_id=each.id,type=1,p_id=element.id,update_date=time_,update_user=session.get("id") or 0)
            db.session.add(pre)
    
def delete_ele(each):
    db.session.query(Permissions).filter(Permissions.type==1,Permissions.p_id==each.get("id")).delete()
    db.session.query(Element).filter_by(id=each.get("id")).delete()
    
def edit_ele(each):
    db.session.query(Element).filter_by(id=each.get("id")).update(each)
    
    
@identity.route("/update_meun/<id_>",methods=["POST"])
def update_meun(id_):
    id_=int(id_)
    data=request.json
    old_elements=sqlOrmToJson(db.session.query(Element.id,Element.u_id,Element.name,Element.default_show).filter(Menu.id==Element.menu_id,Menu.id==id_).all())
    new_elements=data.get("elements")
    new_ids=[id_["id"] for id_ in new_elements if id_.get("id")]
    add_eles=list(filter(lambda x:x not in old_elements,new_elements))
    del_eles=list(filter(lambda x:x not in new_elements,old_elements))
    edit_eles=list(filter(lambda x:x.get("id") not in new_ids and x not in old_elements,new_elements))
    
    db.session.query(Menu).filter_by(id=id_).update({"name":data.get("name"),"router":data.get("router"),"icon":data.get("icon"),"default_show":data.get("default_show")})
    [add_ele(each,id_,time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(time.time()))) for each in add_eles]
    [delete_ele(each) for each in del_eles]
    [edit_ele(each) for each in edit_eles]
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "更新成功"}),200
    
@identity.route("/meun_list",methods=["GET"])
def meun_list():
    menu_all=db.session.query(Menu.id,Menu.name,Menu.router,Menu.icon,Menu.path,Menu.default_show).all()
    menu_all=sorted(menu_all,key=lambda x:len(list(filter(None,x.path.split("/")))),reverse=False)
    result=[]
    for each in menu_all:
        parent_id,parent_name=0,''
        target=result
        info=list(filter(None,each.path.split("/")))
        for path in info:
            breakinfo=False
            for index in range(len(target)):
                if target[index]["id"]==int(path):
                    target[index]["_showChildren"]=True
                    parent_id,parent_name=target[index]["id"],target[index]["name"]
                    target=target[index]["children"]
                    breakinfo=True
                    break
            if not breakinfo:
                elements=db.session.query(Element.name,Element.id,Element.default_show,Element.u_id).filter(Element.menu_id==each.id).all()
                target.append({"parent_id":parent_id,"parent_name":parent_name,"default_show":each.default_show,"name":each.name,"id":each.id,"router":each.router,"icon":each.icon,"elements":sqlOrmToJson(elements),"children":[]})
        target=result
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功", "data": result}),200
    
    
  
@identity.route("/meun",methods=["GET"])
def meun():
    user_id=session.get("id")
    Menu_all=db.session.query(Menu.name,Menu.router,Menu.parent_id,Menu.id,Menu.path).filter(Permissions.type==0,Menu.id==Permissions.p_id,Permissions.role_id==Role.id,User.id==user_id,User.role_id==Role.id).all()
    db.session.close()
    Menu_all=sorted(Menu_all,key=lambda x:len(list(filter(None,x.path.split("/")))),reverse=False)
    result=[]
    for each in Menu_all:
        target=result
        info=list(filter(None,each.path.split("/")))
        for path in info:
            breakinfo=False
            for index in range(len(target)):
                if target[index]["id"]==int(path):
                    target=target[index]["children"]
                    breakinfo=True
                    break
            if not breakinfo:
                target.append({"name":each.name,"router":each.router,"id":each.id})
        target=result
    return jsonify({"code": 200, "message": "请求成功", "data": result}),200
        
@identity.route("/add_element",methods=["POST"])
def add_element():
    data=request.json
    time_ = time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(time.time()))
    element=Element(u_id=data.get("u_id"),name=data.get("name"),default_show=data.get("default_show") or 0)
    db.session.add(element)
    db.session.flush()
    if element.default_show:
        allRole=db.session.query(Role.id).all()
        for each in allRole:
            pre=Permissions(role_id=each.id,type=1,p_id=element.id,update_date=time_,update_user=session.get("id") or 0)
            db.session.add(pre)
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "添加成功"}),200

@identity.route("/delet_element/<id_>",methods=["DELETE"])
def delet_element(id_):
    db.session.query(Permissions).filter(Permissions.type==1,Permissions.p_id==id_).delete()
    db.session.query(Element).filter_by(id=id_).delete()
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "删除成功"}),200

@identity.route("/get_element/<menu_id>",methods=["GET"])
def get_element(menu_id):
    result=db.session.query(Element.id,Element.u_id,Element.name).join(Permissions,Permissions.p_id==Element.id).join(User,User.role_id==Permissions.role_id).join(Menu,Menu.id==Element.menu_id).filter(User.id==session.get("id"),Menu.id==menu_id).all()
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功","data":sqlOrmToJson(result)}),200
            
  


        
    