
import re
import time
import uuid
from flask import Blueprint, request, jsonify,session,current_app
from manager.serverCenter import server
from model.Model import User,Emails,Uploadecase
import base64
import requests
from bs4 import BeautifulSoup
from manager.tools import sqlOrmToJson
import xmindparser
from copy import deepcopy
from manager.tools import par_path
import os
from threading import Thread
from flask_socketio import emit,send

db=server.db
tool = Blueprint("tools", __name__, url_prefix='/tool')
jiraAddress="http://jira.galaxy-immi.com"

def getheader(id_):
    result=db.session.query(User.jira_account,User.jira_password).filter_by(id=id_).first()
    db.session.close()
    if not result.jira_account and not result.jira_password:
        return
    headers={
        "Authorization":"Basic "+base64.b64encode((result.jira_account+":"+result.jira_password).encode('utf-8')).decode(),
        "accept":"application/json,text/javascript,*/*;q=0.01"
    }
    return headers

    
@tool.route('/testport/sendport', methods=["POST"])
def sendport():
    import yagmail
    data=request.json
    user_info=db.session.query(User.email_address,User.email_password).filter_by(id=session.get("id")).first()
    db.session.close()
    if not (user_info.email_address and user_info.email_password):
        return jsonify({"code": 502, "message": "请完善个人邮箱"}),502
    user = user_info.email_address
    password = user_info.email_password
    try:
        yag = yagmail.SMTP( user=user, password=password, host='smtp.exmail.qq.com',port=465)
        yag.send(to=data["to"],cc=data["cc"],subject=data.get("subject"),contents=data.get("contents"))
    except:
        return jsonify({"code": 502, "message": "发送失败，请检查邮箱信息是否正确或是否开启pop3"}),502
    return jsonify({"code": 200, "message": f"{data.get('subject')}邮件发送成功"}),200
    
@tool.route('/testport/getproject', methods=["GET"])
def getproject():
    headers=getheader(session.get("id"))
    if not headers:
        return jsonify({"code": 502, "message": "请完善jira信息"}),502
    result=requests.request("get",jiraAddress+"/rest/api/2/project",headers=headers)
    if result.status_code==200:
        return jsonify({"code": 200, "message": "请求成功", "data": result.json()}),200
    else:
        return jsonify({"code": 402, "message": "未找到相关项目，请确认jira信息是否正确"}),402
    
@tool.route('/testport/iteration/<getproject>', methods=["GET"])
def iteration(getproject):
    headers=getheader(session.get("id"))
    if not headers:
        return jsonify({"code": 502, "message": "请完善jira信息"}),502
    id_=requests.request("get",jiraAddress+"/rest/agile/1.0/board?projectKeyOrId="+getproject,headers=headers).json().get("values")[0].get("id")
    result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/plan/backlog/data.json?rapidViewId="+str(id_),headers=headers).json()
    res=[]
    for each in result["sprints"]:
        res.append({"key":each["id"],"name":each["name"]})
    if res:
        return jsonify({"code": 200, "message": "请求成功", "data": res}),200
    else:
        return jsonify({"code": 402, "message": "未找到相关项目，请确认jira信息是否正确"}),402
    
@tool.route('/testport/reportinfo', methods=["GET"])
def reportinfo():
    project=request.args.get("project")
    iteration=request.args.get("iteration")
    headers=getheader(session.get("id"))
    id_=requests.request("get",jiraAddress+"/rest/agile/1.0/board?projectKeyOrId="+project,headers=headers).json().get("values")[0].get("id")
    result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/plan/backlog/data.json?rapidViewId="+str(id_),headers=headers).json()
    all_=result.get("issues")
    status={}
    for k,v in result["entityData"]["statuses"].items():
        status[k]=v["statusName"]
    priority={}
    for k,v in result["entityData"]["priorities"].items():
        priority[k]=v["priorityName"]
    type_={}
    for k,v in result["entityData"]["types"].items():
        type_[str(k)]=v["typeName"]
        
    spList=[]
    sprint=None
    for i in result["sprints"]:
       if i["id"]==int(iteration):
           spList=i["issuesIds"]
           sprint=i["name"]
           break
    #    x:type_[x["typeId"]]=="测试用例"
    iterationitems=list(filter(lambda x:x["id"] in spList,all_))
    peoples={'test':[],'qian':[],'hou':[],'chan':[]}
    story=list(filter(lambda x:type_[x["typeId"]]=="Story",iterationitems))
    bug=list(filter(lambda x:type_[x["typeId"]]=="BUG",iterationitems))
    testcase=list(filter(lambda x:type_[x["typeId"]]=="测试用例",all_))
    keylist=list(map(lambda x:x.get("key"),testcase))
    for i in story:
        print(i)
        i["case"]=[]
        i["childrenTask"]=[i.get("key")]
        chan=''
        for m in i.get("extraFields") or []:
            if m.get("id")=="reporter":
                chan=m.get("html")
                break
        if not chan:
            chan=i.get("assigneeName")
        if chan and chan not in peoples["chan"]:
            peoples["chan"].append(chan)
        i["peoples"]=[chan]
        info=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/issue/details.json?rapidViewId="+str(id_)+"&issueIdOrKey="+i["key"]+"&loadSubtasks=true",headers=headers).json()
        for j in info.get("tabs").get("defaultTabs"):
            if j.get("tabId")=="SUB_TASKS":
                for m in j.get("subtaskEntries"):
                    k=None
                    if m.get("assignee"):
                        k=m.get("assignee").get("displayName")
                        if k not in i["peoples"]:
                            i["peoples"].append(k)
                    if (k and ( k in peoples["test"] or k in peoples["qian"] or k in peoples["hou"])) or not k:
                        continue
                    elif "【前端】" in m.get("summary"):
                        peoples["qian"].append(k) 
                    elif "【后端】" in m.get("summary"):
                        peoples["hou"].append(k)
                    elif ("测试" in m.get("summary") or "用例" in m.get("summary")):    
                        peoples["test"].append(k) 
                    i["childrenTask"].append(m.get("key"))
            elif j.get("tabId")=="THIRD_PARTY_TAB":
                for each in j.get("sections"):
                    if each["label"]=="测试用例":
                        soup=BeautifulSoup(each["html"],"html.parser")
                        i["case"]=[i.next_element for i in soup.select('tr>td[align="left"]>span>a') if i.next_element in keylist]
    for i in bug:
        info=requests.request("get",jiraAddress+"/rest/api/latest/issue/"+i.get("key"),headers=headers).json()
        m=requests.request("get",jiraAddress+"/secure/AjaxIssueEditAction!default.jspa?decorator=none&issueId="+str(i.get("id")),headers=headers).json()
        count=0
        for j in m.get("fields"):
            if j.get("label")=="严重程度":
                i["Severity"]=info["fields"][j.get("id")] and info["fields"][j.get("id")].get("value") or ""
                count+=1
            if j.get("label")=="BUG修复者":
                i["ascription"]=info["fields"][j.get("id")] and info["fields"][j.get("id")].get("displayName") or i.get("assigneeName")
                count+=1
            if count>=2:
                break
    res={"project":result["projects"][0]["name"],"sprint":sprint,"people":peoples,"story":story,"bug":bug,"testcase":testcase,"statusMap":status,"priorityMap":priority,"typeMap":type_}
    return jsonify({"code": 200, "message": "请求成功", "data": res}),200 


@tool.route('/testport/addemailuser', methods=["POST"])
def addemailuser():
    data=request.json
    addinfo=Emails(name=data.get("name"),address=data.get("address"))
    db.session.add(addinfo)
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功"}),200

@tool.route('/testport/deleteemailuser/<id_>', methods=["DELETE"])
def deleteemailuser(id_):
    db.session.query(Emails).filter_by(id=id_).delete()
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功"}),200

@tool.route('/testport/emailuserlist', methods=["GET"])
def emailuserlist():
    data=db.session.query(Emails.id,Emails.name,Emails.address,Emails.default_cc).all()
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功","data": sqlOrmToJson(data)}),200

@tool.route('/testport/editemailuser', methods=["POST"])
def editemailuser():
    db.session.query(Emails).filter_by(id=request.json.get("id")).update({"name":request.json.get("name"),"address":request.json.get("address")})
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功"}),200

@tool.route('/testport/changedefaultCC/<id_>', methods=["POST"])
def changedefaultCC(id_):
    a=db.session.query(Emails).filter_by(id=int(id_)).first()
    a.default_cc=int(not a.default_cc)
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "修改成功"}),200

@tool.route('/testport/defaultCClist', methods=["GET"])
def defaultCClist():
    data=db.session.query(Emails.id,Emails.name,Emails.address,Emails.default_cc).filter(Emails.default_cc==1).all()
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功","data": sqlOrmToJson(data)}),200


@tool.route('/testcase/uploadhistory', methods=["GET"])
def uploadhistory():
    data=request.args
    page_size = int(data.get("page_size"))
    page_num = int(data.get("page_num"))
    result=db.session.query(Uploadecase.id,Uploadecase.filename,Uploadecase.project,Uploadecase.step,Uploadecase.stepstatus,Uploadecase.status,Uploadecase.create_time,Uploadecase.case_count).filter_by(user_id=session.get("id")).order_by(Uploadecase.create_time.desc()).paginate(page=page_num, per_page=page_size)
    total_sum = result.total
    res = result.items
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功","data":{"rows":sqlOrmToJson(res),"total": total_sum}}),200
    
@tool.route('/testcase/upload',methods=["POST"])
def run():
    
    a=Uploadecase(project=request.form.get("projectName"),user_id=session.get("id"),step=0,stepstatus=0,status=0,create_time=time.strftime('%Y-%m-%d %H:%M:%S',time.localtime(time.time())))
    if 'file' not in request.files:
        a.stepstatus=1
        a.status=1
        db.session.add(a)
        db.session.commit()
        db.session.close()
        return jsonify({"code": 503, "message": "请选择文件"}),503
    file = request.files['file']
    if file.filename.split(".")[-1]!="xmind":
        a.stepstatus=1
        a.status=1
        db.session.add(a)
        db.session.commit()
        db.session.close()
        return jsonify({"code": 503, "message": "文件格式错误"}),503
    a.filename=file.filename
    file_name=str(uuid.uuid1())+'.'+file.filename.split(".")[-1]
    file.save(par_path+"/uploadfile/"+file_name)
    db.session.add(a)
    db.session.flush()
    upid=a.id
    db.session.commit()
    db.session.close()
    server.socketio.start_background_task(runstart,current_app._get_current_object(),file_name,request.form.get("project"),upid,session.get("id"))
    server.socketio.emit("infoupdate",room=upid)
    return jsonify({"code": 200, "message": "上传成功"}),200
    
def runstart(app,file_name,project,upid,user_id): 
    with app.app_context():
        headers=getheader(user_id)
        id_=requests.request("get",jiraAddress+"/rest/agile/1.0/board?projectKeyOrId="+project,headers=headers).json().get("values")[0].get("id")
        result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/plan/backlog/data.json?rapidViewId="+str(id_),headers=headers).json()
        projectId,projectkey=result["projects"][0]["id"],result["projects"][0]["key"]
        data={ "fields": {
            "project": {
                "key": projectkey
            },
            "summary": "测试占位",
            "description": "文辉的测试",
            "issuetype": {
                "name": "测试用例"
            },
        }
        }
        result=requests.request("post",jiraAddress+"/rest/api/2/issue/",json=data,headers=headers).json()
        globalcaseId=result["id"]
        def up(suiteName,suiteId,info,new,type):
            sums=0
            m=suiteName
            for each in info:
                suiteName=m
                oldinfo,newtype=deepcopy(new),type
                if not ((each["title"])=="Map" or (each["title"])=="测试用例" or (each["title"])=="sheet" or (each["title"])=="思维导图" or (each["title"])=="逻辑图" or (each["title"])=="括号图" or "画布" in (each["title"])):
                    if not suiteName:
                        suiteName = each.get("title")
                        params={"tcIssueId":globalcaseId,"projectId":projectId,"sourcePage":"TEST_SUITE_TEST_CASE_PAGE","decorator":"dialog","inline":True}
                        requests.request("post",jiraAddress+"/secure/CreateTestSuite.jspa?projectId="+str(projectId),data={"inline":True,"decorator":"dialog","testSuiteName":suiteName},headers=headers)
                        text=requests.request("get",jiraAddress+"/secure/ShowLinkTestSuiteInPanel.jspa",params=params,headers=headers).content
                        soup=BeautifulSoup(text,"html.parser")
                        suiteId=soup.find("strong",string=suiteName).parent.find("input").attrs.get("value") 
                    if type=="name":
                        string=each.get("title")
                        if "tc：" in each.get("title") or "tc：" in each.get("title") or "tc:" in each.get("title"):
                            string,newtype=each.get("title").replace("tc：","").replace("tc：","").replace("tc:",""),"step"
                        oldinfo["name"]=oldinfo.get("name") and oldinfo.get("name")+"->"+string or string
                    elif type=="step":
                        newtype,oldinfo["step"]="expect",each.get("title")
                    else:
                        oldinfo["expect"]=each.get("title")
                if each.get("topic") or each.get("topics"):
                    sums= sums+ (each.get("topic") and up(suiteName,suiteId,[each.get("topic")],oldinfo,newtype) or 0)
                    sums = sums + (each.get("topics") and up(suiteName,suiteId,each.get("topics"),oldinfo,newtype) or 0)
                else:
                    testId=requests.request("post",jiraAddress+"/rest/api/2/issue/",json={ "fields": {
                        "project": {
                            "key": projectkey
                        },
                        "summary": oldinfo["name"],
                        "issuetype": {
                            "name": "测试用例"
                        },
                    }
                    },headers=headers).json()["id"]
                    requests.request("post",jiraAddress+"/rest/synapse/1.0/testStep/addTestStep",json={"tcId":testId,"step":oldinfo.get("step"),"expectedResult":oldinfo.get("expect"),"sequenceNumber":None},headers=headers)
                    requests.request("post",jiraAddress+"/rest/synapse/latest/testSuite/addTestCaseMemberToTestSuites",json={"testSuiteIds":[suiteId],"testCaseId":testId},headers=headers)
                    sums=sums+1
            return sums
        
        def relevancycase(pro):
            id_=requests.request("get",jiraAddress+"/rest/agile/1.0/board?projectKeyOrId="+pro,headers=headers).json().get("values")[0].get("id")
            result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/plan/backlog/data.json?rapidViewId="+str(id_),headers=headers).json()
            projectkey=result["projects"][0]["key"]
            result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/plan/backlog/data.json?rapidViewId="+str(id_)+"&selectedProjectKey="+projectkey,headers=headers).json()
            all,type_,storyids=result.get("issues"),{},{}
            for k,v in result["entityData"]["types"].items():
                type_[str(k)]=v["typeName"]
            [storyids.update({i.get("key"):[]}) for i in list(filter(lambda x:type_[x["typeId"]]=="Story",all))]
            for item in list(filter(lambda x:type_[x["typeId"]]=="测试用例",all)):
                for each in storyids.keys():
                    each in item.get("summary") and storyids[each].append(item.get("key"))
            for k,v in storyids.items():
                requests.request("post",jiraAddress+"/rest/synapse/latest/requirementTestCase/addTestCase",headers=headers,json={"currentReqkey":k,"testCaseKeys":v,"history":"yes"})
            return jsonify({"code": 200, "message": "用例关联执行结束"}),200
        
        a=db.session.query(Uploadecase).filter_by(id=upid).first()
        a.step=1
        a.stepstatus=0
        db.session.commit()
        server.socketio.emit("infoupdate",room=a.id)
        content= xmindparser.xmind_to_dict(par_path+"/uploadfile/"+file_name)
        try:
            sums=up(None,None,content,{},"name")
            requests.request("delete",jiraAddress+"/rest/api/2/issue/"+globalcaseId,headers=headers)
            a.step=2
            a.stepstatus=0
            a.case_count=sums
            db.session.commit()
            server.socketio.emit("infoupdate",room=a.id)
        except:
            a.stepstatus=1
            a.status=1
            a.case_count=sums
            db.session.commit()
            server.socketio.emit("infoupdate",room=a.id)
            db.session.close()
            return
        try:
            relevancycase(project)
            a.step=3
            a.stepstatus=2
            a.status=1
            db.session.commit()
            server.socketio.emit("infoupdate",room=a.id)
        except:
            a.stepstatus=1
            a.status=1
            db.session.commit()
            server.socketio.emit("infoupdate",room=a.id)
        db.session.close()
        
@tool.route('/testport/autoprojects', methods=["GET"])
def autoprojects():
    result=server.auto_jenkins._get_view_jobs("全流程")
    return jsonify({"code": 200, "message": "请求成功","data":result}),200

@tool.route('/testport/runjobs', methods=["POST"])
def runbuild():
    data=request.json
    for each in data:
        server.auto_jenkins.build_job(each)
    return jsonify({"code": 200, "message": "请求成功"}),200

def jobreporterpath(name):
    a=str((name+"测试报告").encode('UTF-8'))[1:].replace('\'','').split('\\')
    result=''
    count=0
    l=''
    for each in a:
        if (not each) or (each[0]!='x'):
            result+=each
            continue
        count=count+1
        l+=each[1:]
        if count==3:
            result=result+"_"+l
            count,l=0,''
    return result

@tool.route('/testport/runresult', methods=["GET"])
def runresult():
    reportMap={
        "DWP各页面主流程接口":"DWP各页面主流程接口",
        "smart-writing":"smart-writing接口",
        "sop以及私域":"sop接口",
        "全it":"全it",
        "售前总流程ling":"售前Ling接口",
        "售后主流程":"售后主流程接口",
        "银河E签接口自动化":"银河E签接口自动化"

    }
    p = re.compile(r'echo total=(\d+)\s.+echo success=(\d+)\s.+echo fail=(\d+)', re.MULTILINE)
    data=server.auto_jenkins._get_view_jobs("全流程")
    m=[]
    # m=map(lambda x:{""})
    for each in data:
        k={"job":each["name"]}
        number=server.auto_jenkins.get_job_info(each["name"]).get("builds")[0]["number"]
        info=server.auto_jenkins.get_build_info(each["name"],number)
        logs=server.auto_jenkins.get_build_console_output(each["name"],number)
        res=p.findall(logs)
        if res:
            k["total"]=res[0][0]
            k["success"]=res[0][1]
            k["fail"]=res[0][2]
        k["running"],k['result'],k['time']=info["building"],info["result"],time.strftime("%Y-%m-%d %H:%M:%S",time.localtime(float(info["timestamp"])/1000))
        k["reportPath"]=server.auto_jenkins.server+'view/全流程/job/'+each["name"]+'/'+jobreporterpath(reportMap[each["name"]])
        m.append(k)
    return jsonify({"code": 200, "message": "请求成功","data":m}),200

@tool.route('/testport/allscript', methods=["GET"])
def allscript():
    return jsonify({"code": 200, "message": "请求成功","data":server.auto_jenkins._get_view_jobs("全流程")}),200

@tool.route('/testport/test', methods=["GET"])
def test():
    a=server.auto_jenkins.get_job_info('app自动化测试',8)
    return jsonify({"code": 200, "message": "请求成功","data":a}),200
    
      

      
        
        
    