import os
import requests
from urllib.parse import urlparse
from copy import deepcopy
import xmindparser
import base64
import requests
from bs4 import BeautifulSoup
from flask import Blueprint, request,jsonify
from threading import Thread

jiraAddress="http://jira.galaxy-immi.com"

notoken = Blueprint("notoken", __name__, url_prefix='/notoken')

runinfo={}

def download_file(id,url):
    global runinfo
    runinfo[id]=0
    response = requests.get(url, stream=True)
    response.raise_for_status()
    download_dir = './upload'
    os.makedirs(download_dir, exist_ok=True)
    file_name = os.path.basename(urlparse(url).path)
    file_path = os.path.join(download_dir, file_name)
    with open(file_path, 'wb') as file:
        for chunk in response.iter_content(chunk_size=8192):
            if chunk:
                file.write(chunk)
    return file_path



def uploadcase(id,project,file_path,headers):
    global runinfo
    runinfo[id]=1
    id_=requests.request("get",jiraAddress+"/rest/agile/1.0/board?projectKeyOrId="+project,headers=headers).json().get("values")[0].get("id")
    result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/plan/backlog/data.json?rapidViewId="+str(id_),headers=headers).json()
    projectId,projectkey=result["projects"][0]["id"],result["projects"][0]["key"]
    data={ "fields": {
        "project": {
            "key": projectkey
        },
        "summary": "测试占位",
        "description": "文辉的测试",
        "issuetype": {
            "name": "测试用例"
        },
    }
    }
    result=requests.request("post",jiraAddress+"/rest/api/2/issue/",json=data,headers=headers).json()
    globalcaseId=result["id"]
    content= xmindparser.xmind_to_dict(file_path)
    def a(suiteName,suiteId,info,new,type):
        for each in info:
            oldinfo,newtype=deepcopy(new),type
            if not ((each["title"])=="Map" or (each["title"])=="测试用例" or (each["title"])=="sheet" or (each["title"])=="思维导图" or (each["title"])=="逻辑图" or (each["title"])=="括号图" or "画布" in (each["title"])):
                if not suiteName:
                    suiteName = each.get("title")
                    params={"tcIssueId":globalcaseId,"projectId":projectId,"sourcePage":"TEST_SUITE_TEST_CASE_PAGE","decorator":"dialog","inline":True}
                    requests.request("post",jiraAddress+"/secure/CreateTestSuite.jspa?projectId="+str(projectId),data={"inline":True,"decorator":"dialog","testSuiteName":suiteName},headers=headers)
                    text=requests.request("get",jiraAddress+"/secure/ShowLinkTestSuiteInPanel.jspa",params=params,headers=headers).content
                    soup=BeautifulSoup(text,"html.parser")
                    suiteId=soup.find("strong",string=suiteName).parent.find("input").attrs.get("value") 
                if type=="name":
                    string=each.get("title")
                    if "tc：" in each.get("title") or "tc：" in each.get("title") or "tc:" in each.get("title"):
                        string,newtype=each.get("title").replace("tc：","").replace("tc：","").replace("tc:",""),"step"
                    oldinfo["name"]=oldinfo.get("name") and oldinfo.get("name")+"->"+string or string
                elif type=="step":
                    newtype,oldinfo["step"]="expect",each.get("title")
                else:
                    oldinfo["expect"]=each.get("title")
            if each.get("topic") or each.get("topics"):
                each.get("topic") and a(suiteName,suiteId,[each.get("topic")],oldinfo,newtype)
                each.get("topics") and a(suiteName,suiteId,each.get("topics"),oldinfo,newtype)
            else:
                testId=requests.request("post",jiraAddress+"/rest/api/2/issue/",json={ "fields": {
                    "project": {
                        "key": projectkey
                    },
                    "summary": oldinfo["name"],
                    "issuetype": {
                        "name": "测试用例"
                    },
                }
                },headers=headers).json()["id"]
                requests.request("post",jiraAddress+"/rest/synapse/1.0/testStep/addTestStep",json={"tcId":testId,"step":oldinfo.get("step"),"expectedResult":oldinfo.get("expect"),"sequenceNumber":None},headers=headers)
                requests.request("post",jiraAddress+"/rest/synapse/latest/testSuite/addTestCaseMemberToTestSuites",json={"testSuiteIds":[suiteId],"testCaseId":testId},headers=headers)
    a(None,None,content,{},"name")
    requests.request("delete",jiraAddress+"/rest/api/2/issue/"+globalcaseId,headers=headers)
    os.remove(file_path)
    
def relevancycase(id,project,headers):
    global runinfo
    runinfo[id]=2
    id_=requests.request("get",jiraAddress+"/rest/agile/1.0/board?projectKeyOrId="+project,headers=headers).json().get("values")[0].get("id")
    result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/plan/backlog/data.json?rapidViewId="+str(id_),headers=headers).json()
    projectkey=result["projects"][0]["key"]
    result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/plan/backlog/data.json?rapidViewId="+str(id_)+"&selectedProjectKey="+projectkey,headers=headers).json()
    all,type_,storyids=result.get("issues"),{},{}
    for k,v in result["entityData"]["types"].items():
        type_[str(k)]=v["typeName"]
    [storyids.update({i.get("key"):[]}) for i in list(filter(lambda x:type_[x["typeId"]]=="Story",all))]
    for item in list(filter(lambda x:type_[x["typeId"]]=="测试用例",all)):
        for each in storyids.keys():
            each in item.get("summary") and storyids[each].append(item.get("key"))
    for k,v in storyids.items():
        requests.request("post",jiraAddress+"/rest/synapse/latest/requirementTestCase/addTestCase",headers=headers,json={"currentReqkey":k,"testCaseKeys":v,"history":"yes"})
    
def run(id,url,project):
    id=int(id)
    headers={
        "Authorization":"Basic "+base64.b64encode(("betty.zww:AAAaaa111").encode('utf-8')).decode(),
        "accept":"application/json,text/javascript,*/*;q=0.01"
    }
    file_path=download_file(id,url) 
    uploadcase(id,project,file_path,headers)
    relevancycase(id,project,headers)
    global runinfo
    del runinfo[id]
    
@notoken.route('/uploadcase', methods=["POST"])
def uploadcase():
    thr=Thread(target=run,args=(request.json.get("id"),request.json.get("url"),request.json.get("project")))
    thr.start()
    return jsonify({"code": 200, "message": "请求成功"}),200


@notoken.route('/upstatus/<id_>', methods=["GET"])
def upstatus(id_):
    id_=int(id_)
    global runinfo
    return jsonify({"code": 200, "message": "请求成功","status":runinfo.get(id_)}),200