from flask import Flask
import os
from flask_sqlalchemy import SQLAlchemy
from flask_socketio import SocketIO
from datetime import timedelta
from manager.tools import get_config
from jenkins import Jenkins


config=get_config()
mysqlConf=config["mysql"]

class server():
    app = Flask(__name__, template_folder='auto_test/html', static_folder='')
    app.config['SQLALCHEMY_DATABASE_URI'] = f"mysql+pymysql://{mysqlConf['user']}:{mysqlConf['password']}@{mysqlConf['host']}:{mysqlConf['port']}/{mysqlConf['db']}?charset=utf8mb4"
    app.config['SQLALCHEMY_TRACK_MODIFICATIONS'] = True
    app.config['SECRET_KEY'] = os.urandom(24)
    app.config['PERMANENT_SESSION_LIFETIME'] = timedelta(days=7)
    app.secret_key = "test"
    db = SQLAlchemy(app)
    socketio = SocketIO()
    socketio.init_app(app, cors_allowed_origins='*')
    auto_jenkins=Jenkins('http://192.168.11.185:8080/',"admin0001","123456")
    
    
    

        


