import os
import sys
import uuid
from apscheduler.jobstores.sqlalchemy import SQLAlchemyJobStore
from manager.serverCenter import server
from controller.socketevent import *
from manager.tools import par_path

class Config(object):
    JOBS = []
    SCHEDULER_API_ENABLED = True
    SCHEDULER_TIMEZONE = 'Asia/Shanghai'
    SCHEDULER_JOBSTORES = {
        'default': SQLAlchemyJobStore(url=server.app.config['SQLALCHEMY_DATABASE_URI'])
    }

@server.app.before_request
def token():
    token = request.headers.get("token")
    release_path = ["/user/login", "/user/logout",'notoken']
    next_=False
    for i in release_path:
        if i in request.path:
            next_=True
            break
    if next_:
        pass
    elif token is None:
        db.session.close()
        return jsonify({"code": 401, "message": "登陆已过期"}),401
    elif not session.get("id"):
        m=db.session.query(User).filter_by(token=token).first()
        db.session.close()
        if m:
            session["id"]=m.id
            session['token']=token
        else:
            return jsonify({"code": 401, "message": "登陆已过期"}),401
    elif db.session.query(User.token).filter_by(id=session.get("id")).first()[0] == token:
        session['token']=token
        db.session.close()
        pass
    else:
        return jsonify({"code": 401, "message": "登陆已过期"}),401
@server.app.route('/upload',methods=["POST"])
def upload():
    if 'file' not in request.files:
        return jsonify({"code": 503, "message": "请选择文件"}),503
    file = request.files['file']
    l=file.filename.split(".")
    if file:
        print(file.__dict__)
        if len(l)>=2:
            file_name=str(uuid.uuid1())+'.'+l[-1]
        else:
            return jsonify({"code": 503, "message": "文件格式错误"}),503
        # 存储文件
        file.save(par_path+"/uploadfile/"+file_name)
        return jsonify({"code": 200, "message": "上传成功","data":{"filename":file_name}}),200

if __name__ == '__main__':
    rel_path = os.path.dirname(os.path.realpath(__file__))
    if rel_path not in sys.path:
        sys.path.append(rel_path)

    server.app.config.from_object(Config())
    from controller.User import *
    server.app.register_blueprint(user)
    
    from controller.Identity import *
    server.app.register_blueprint(identity)
    
    from controller.Tool import *
    server.app.register_blueprint(tool)
    
    from controller.notoken import *
    server.app.register_blueprint(notoken)
    
    # server.app.run(host="0.0.0.0", port=8000, debug=True)
    server.socketio.run(server.app, host="0.0.0.0", port=8000, debug=True,allow_unsafe_werkzeug=True)
    
    
    

